config/routes.rb
Rails.application.routes.draw do
  get 'readings/index'

  devise_for :users
  resources :readings do
    collection do
      get :report
      get :generate_report
    end
  end

  devise_scope :user do
    authenticated do
      root "readings#new"
    end
    unauthenticated do
      root "devise/sessions#new", as: :unauthenticated_root
    end
  end
end

app/models/reading.rb
class Reading < ActiveRecord::Base

  MAX_READING_PER_DAY = 4

  #scopes
  default_scope { order(created_at: :desc) }
  scope :this_day, ->(date) {where(created_at: (date.to_date.beginning_of_day..date.to_date.end_of_day))}
  scope :month_to_date, ->(date) {where(created_at: (date.to_date.beginning_of_month.beginning_of_day..date.to_date.end_of_day) )}
  scope :monthly, ->(date) {where(created_at: (date.to_date.beginning_of_month.beginning_of_day..date.to_date.end_of_month.end_of_day))}
  scope :max_label, -> {maximum('label')}
  scope :min_label, -> {minimum('label')}
  scope :avg_label, -> {average('label').round(2)}

  #associations
  belongs_to :user

  #validations
  validates :label, numericality: {only_integer: true, greater_than: 0}, presence: true
  validate :max_reading_per_day, on: :create

  def self.to_csv
    attributes = %w(created_at label)
    CSV.generate(headers: true) do |csv|
      csv << (attributes + %w(maximum minimum average))
      all.each_with_index do |reading, index|
        csv << ( index == 0 ? attributes.map{|attr| reading.send(attr)} + [all.max_label, all.min_label, all.avg_label] :
            attributes.map{|attr| reading.send(attr)})
      end
    end
  end

  private

    def max_reading_per_day
      if user.readings.this_day(Date.today).count >= MAX_READING_PER_DAY
        errors[:base] << I18n.t("active_record.reading.max_reading_per_day", count: MAX_READING_PER_DAY)
      end
    end


end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :readings, dependent: :destroy
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception, except: :generate_report
end

app/controllers/readings_controller.rb
class ReadingsController < ApplicationController

  include ReadingsHelper

  before_action :authenticate_user!
  before_action :readings_of_the_day, except: [:report, :generate_report]
  before_action :reading_instance, only: :destroy

  def new
    @reading = Reading.new
  end

  def create
    @reading = current_user.readings.create(reading_params)
  end

  def destroy
    @reading.destroy
  end

  def report
  end

  def generate_report
    begin
      date = Date.parse(params[:date])
      report_type = params[:report_type]
      if  report_type && date
        case report_type
          when "daily"
            @readings = current_user.readings.this_day(date)
          when "month_to_date"
            @readings = current_user.readings.month_to_date(date)
          when "monthly"
            @readings = current_user.readings.monthly(date)
        end
      end
      respond_to do |format|
        format.js
        format.csv {send_data @readings.to_csv,content_type: 'text/csv', disposition: 'attachment', filename: "#{report_type}_#{date}.csv" }
      end
    rescue
      redirect_to report_readings_path
    end
  end

  private

    def reading_params
      params.require(:reading).permit(:label)
    end

    def readings_of_the_day
      @readings = current_user.readings.this_day(Time.current.to_date)
    end

    def reading_instance
      @reading = Reading.find_by_id(params[:id])
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
	def flash_type(type)
		#binding.pry
		case type
		when "success"
			"success"
		when "alert"
			"warning"
		else
			"info"
		end
	end
end

app/helpers/readings_helper.rb
module ReadingsHelper
  def report_types
    {daily: t('readings.report.daily'),month_to_date: t('readings.report.month_to_date'),monthly: t('readings.report.monthly')}
  end
end

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
    %title Sweety
    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true
    = javascript_include_tag 'application', 'data-turbolinks-track' => true
    = csrf_meta_tags
  %body
    = render 'shared/header'
    .container
      - flash.each do |k,v|
        .alert{class: "alert-#{flash_type(k)}"}=v
      = yield

app/views/readings/_reading.html.haml
%tr
  %td
    = reading.created_at.strftime("%I:%M:%S %p")
  %td
    = reading.label
  %td
    = link_to t('readings.new.remove'),reading_path(reading), method: :delete,data: {confirm: t('readings.new.remove_confirm')},class: 'btn btn-danger', remote: true

app/views/readings/_reading_panel.html.haml
.panel.panel-default
  .panel-heading=t('readings.new.reading_panel_heading')
  .panel-body
    %table.table
      %thead
        %tr
          %th=t('readings.new.reading_time')
          %th=t('readings.new.reading_label')
          %th
      %tbody
        = render(readings)

app/views/readings/create.js.erb
<% if @reading.valid? %>
    $("#reading_panel").html("<%= j render partial: 'reading_panel', locals: {readings: @readings} if @readings.any? %>");
    $("#reading_label").val('');
<% else %>
    $("#error_box").html("<%= j render partial: 'shared/error_messages', locals: {reading: @reading} %>");
<% end %>

app/views/readings/destroy.js.erb
$("#reading_panel").html("<%= j render partial: 'reading_panel', locals: {readings: @readings} if @readings.any? %>");

app/views/readings/generate_report.js.erb
$("#report_table").html("<%= j render partial: 'readings/report/report_reading', locals: {readings: @readings} if @readings.any? %>");
$("#report_stats").html("<%= j render partial: 'readings/report/report_stats', locals: {readings: @readings} if @readings.any? %>");

$("#report_datatable").DataTable({
  iDisplayLength: 10,
  bInfo: false,
  bSort: true,
  sPaginationType: "full_numbers",
  bStateSave: true,
  bDestroy: true,
  bProcessing: true,
  bFilter: false,
  aaSorting: [[1, "desc"]],
  oLanguage: {
    sZeroRecords: "No Records found."
  },
  sDom: "rtlfip"
});

app/views/readings/new.html.haml
.row
  .col-md-offset-4.col-md-4.col-sm-offset-3.col-sm-6
    = form_for @reading, html: {class: 'form-inline'}, remote: true do |f|
      #error_box
      .row
        .col-md-9
          .input-group.full-width
            = f.text_field :label, class: 'form-control', placeholder: t('readings.new.lable_placeholder')
            %span.input-group-addon mg/dl
        .col-md-3
          = f.submit t('readings.new.enter'), class: 'btn btn-success full-width'
    #reading_panel
      = render partial: 'reading_panel', locals: {readings: @readings} if @readings.any?

app/views/readings/report.html.haml
.row
  .col-md-offset-4.col-md-4.col-sm-offset-4.col-sm-4#report_box
    = form_tag generate_report_readings_path(format: :csv), method: :get, class: "form-horizontal"
    .form-group
      = select_tag :report_type, options_for_select(report_types.collect { |key, value| [value, key]}),prompt: 'Select Report Type', class: 'form-control'
    .form-group
      .input-group
        = text_field_tag :date,nil,id: 'report_date',class: "datepicker form-control", placeholder: 'Enter Date'
        %span.input-group-addon#btn_calendar
          %span.glyphicon.glyphicon-calendar
    .form-group
      = submit_tag t('readings.report.download_report'), class: 'btn btn-success'
      = submit_tag t('readings.report.view_report'),id: 'view_report',class: 'btn btn-info' 
  .col-md-offset-4.col-md-4.col-sm-4.col-sm-offset-4
    #report_table
  .col-md-4.col-sm-4
    #report_stats

app/views/readings/report/_reading.html.haml
%tr
	%td=reading.created_at
	%td=reading.label

app/views/readings/report/_report_reading.html.haml
%table.table.table-responsive.table-stripped.table-bordered#report_datatable
	%thead
		%tr
			%th Created at
			%th Label
	%tbody
		= render partial: "readings/report/reading", collection: readings, as: :reading

app/views/readings/report/_report_stats.html.haml
%table.table.table-responsive.table-stripped.table-bordered#report_datatable
	%tr
		%th Max
		%th=readings.max_label
	%tr
		%th Min
		%th=readings.min_label
	%tr
		%th Avg
		%th=readings.avg_label

app/views/shared/_error_messages.html.haml
.alert.alert-danger.alert-dismissible
  %button.close{"aria-label" => "Close", "data-dismiss" => "alert", :type => "button"}
    %span{"aria-hidden" => "true"} ×
  - reading.errors.full_messages.each do |msg|
    .error-explanation=msg

app/views/shared/_header.html.haml
%nav.navbar.navbar-default.navbar-fixed-top
  .container-fluid
    .navbar-header
      = link_to root_path, class: 'navbar-brand' do
        = image_tag 'sweety-logo.png', class: 'sweety-logo'

    - if current_user
      %ul.nav.navbar-nav.navbar-right
        %li
          = link_to t('readings.report.report'), report_readings_path
        %li
          = link_to destroy_user_session_path,method: :delete do
            %span.glyphicon.glyphicon-log-out
            = t('views.header.logout')